/**

@author mark, mark@gohosting.co.kr



  Mail encoding/decoding library.

  This class deals with the mail data encoding and decoding...
  - it does MIME parsing, retreiving attachment, checking bad mails, etc...


  MailDecoder Class
  - ޼ ڵ ϴ Ŭ̴.
@todo
	- ޼ ڵϰ   ϸ ,
		ٸ ⿡ ޼ ϴ  ùٸڴ.
		׷, MySQL Ӹ ƴ϶, ٸ ͺ̽ ϴ    .
		 ׽Ʈ ڵ̴ϱ, ϴ ô Ѵ.
*/



#include "_mail.h"
#include "_library.h"


MailDecoder::MailDecoder()
{
}


MailDecoder::~MailDecoder()
{
}



/**

	This method receives only one message data for decoding.
@param	const char *data
	original message data
@todo
	string ü ۷ ޾Ҵµ  簡 Ǿ.
	ϴٸ string ü   ۷ ޾Ƽ Ѵ.

@note
	 ޼ҵ尡 ȣǸ  ޼ Ľ   Ŭϰ
	ʱⰪ ؾѴ.

@important
	Է  const char *data  ü ͸ Ѵ.
	  Ͱ  ü  ߿  ȵȴ.
*/
void MailDecoder::Set(const char *data)
{
	m_data	= data;
	Reset();
}




/**
	 ü  ִ  ޼ ڵ  Ŭϰ,
	ʱⰪ Ѵ.
*/
void MailDecoder::Reset()
{
	m_size	= strlen( m_data );
	m_map_header.erase( m_map_header.begin(), m_map_header.end() );
	m_string_header.erase( m_string_header.begin(), m_string_header.end() );
	m_list_part.erase( m_list_part.begin(), m_list_part.end() );
}





/**
	޼ ĽѴ.
@process
	-   иѴ.
	- ٿ  и Ѵ.
	- attachment  map  Ѵ.
	- inline ߿ content-type  text  ƴ  ÷ Ϸ ؾϹǷ
		map  Ѵ.
@todo
	- ڵ  ڵ  ֵ ؾѴ.
@return
	  0
	MIME 信 ̻ , MALFORMED

*/
/*
deprecated
int MailDecoder::Parse()
{
	// cout << m_data << flush;

	
	if ( ! ParseHeader() )
		return MALFORMED_WRONGHEADER;
	if ( ! ParseBody() )
		return MALFORMED_WRONGBODY;

	return 0;
}
*/

/**
	m_string_header   
	m_map_header    иؼ ִ´.
@note
	 Լ   ĽѴ.
	 Ʈ   Ľϴ    ǵ  ۼ  ,
	 Ʈ     ִ  Ƿ  Լ .
@input
	member variable - m_map_header, m_string_header
@return
	on success, it return true.
	otherwise false.
@note
	m_message_body  ޼   Ѵ.
	, ü ޼ Ͱ Ʈ ޼̰ų content-type  alternative  ,
	  ϳ Ʈ޼,  ʹ  Ų.
@note
	  ʵ Ű ҹڷ ٲ۴.
@todo
	- charset   content-type:    ο ϵȴ.
		charset Ӹƴ϶ boundary 
		Ÿ ϳ       ִ.  ó ؾѴ.
	- content-type: mixed , alternative   ó ؾؾϸ,
		 , ٿ Ÿ  üũؾѴ.
@todo
	   ִ   ִ ̸  ϰڴ.
	׷ 1024 Ʈ ⺻ ϴ , üũ  ƾѴ.
	      ,  ũ  Ŀ  ִ.
	, string Ŭ  Ѵ.
@todo
	 CR ϴ ڵ尡  ȵǾ. üũ .
	{
		if ( *(_key - 1) == '\r')
			*(_key -1) = '\0';
		else
			*_key = '\0';
	}

*/
bool MailDecoder::ParseHeader()
{
	char key[256];
	char value[MAXBUF_HEADERLINE];
	string tmp;

	const char *ptr = m_data;
	char *_key = key, *_value = value;

	do  {
		//    
		if ( ( *ptr == '\r' && *(ptr + 1) == '\n' ) || *ptr == '\n' ) {
			break;
		}

		//  Ű 
		//  ó 鹮ڰ ƴϰ ':'  '\n'  ,   ڴ  Ű̴.
		while ( *ptr && *ptr != ':' && *ptr != '\n' )
			*_key++ = *ptr++;
		
		//  CR 
		if ( *(_key - 1) == '\r')
			*(_key -1) = '\0';
		else
			*_key = '\0';

		// ʿ ':', ' ', '\t'  
		while ( *ptr == ':' || *ptr == ' ' || *ptr == '\t' )
			*ptr++;


		/**
			  
			'\n'     Ѵ.
		*/
		while ( *ptr && *ptr != '\n' )
			*_value++ = *ptr++;

		//  CR 
		if ( *(_value - 1) == '\r') 
			*(_value -1) = '\0';
		else
			*_value = '\0';
		tmp = value;

		/**
			 ΰ    ִ  üũ
			  '\n' ̴.    ' ' ̳ '\t' ̸ 
			 ̴.
		*/
		while ( *(ptr+1) == ' ' || *(ptr+1) == '\t' ) {
			_value = value;
			*ptr ++;
			//  
			while ( *ptr ) {
				if ( *ptr == '\n' ) break;
				*_value++ = *ptr++;
			}
			//  CR 
			if ( *(_value - 1) == '\r') *(_value -1) = '\0';
			else *_value = '\0';
			tmp += value;
		}

		__strlwr( key );

		/**
			see if it has multi-parted value.
		*/
		CheckMultiValue(key, tmp);

		/**
			@todo
			 content-type  , boundary  ã   ־Ѵ.
		*/
		m_map_header.insert(map<string,string>::value_type(key, tmp));
		_key = key;
		_value = value;
	} while ( *ptr++ );

	// *ptr     ִ.
	//  Ѵ.
	m_string_header = string(m_data, 0, ptr - m_data);

	// *ptr    ٵ  Ű ִ.
	//   ġ Ѵ.
	// boundary  ,   ״  ȴ.
	m_message_body = ptr;

	// ⼭ ...  ο ش    óؾ Ѵ.
	//  , charset ̳ boundary  ִ.


	// test print
	PrintHeader();
	//cout << "\n[ orignal message header ]" << endl;
	//cout << m_string_header << endl;


	return true;
}


void MailDecoder::PrintHeader()
{

	cout << "\n[ new message header ]" << endl;
	for ( map<string,string>::iterator k = m_map_header.begin(); k != m_map_header.end(); k++ )
	{
		cout << k->first << ":";
		cout << k->second << endl;
	}
}


/**

  boundary  message body  иѴ.
@note
	- It just parses the MIME.
	- decoding the charset &  checking the bad mails (etc, ...) are another work.
@require
	- ParseHeader() must be called first.
*/
const char *MailDecoder::GetBody()
{

	return m_message_body;
}














/**
	Checks if the value (of header field) has multi-parted form.
@param	const char *value
	a header's value
@return
	true if the value has multi-parted.
	false, otherwise...
@note
	true   , value  key(ʵ)  .
	value  "Ű="    m_map_header  ߰ȴ.
*/

bool MailDecoder::CheckMultiValue(const char *key, string& value)
{


	if ( key == NULL || value.empty() ) return false;

	if ( strcmp( "content-type", key ) == 0
		|| strcmp( "content-disposition", key ) == 0 
		) {

		string::size_type endv	= value.find(';', 0);
		string::size_type sp, ep;
		if ( endv == string::npos ) {
			return false;
		}
		else {
			//cout << key << "#" << value << endl;
			/**
				field  content-type ̰,
				';'  ãҴٸ,  ġ   ߶ ־Ѵ.
			*/
			sp	= value.find_first_not_of( " \t\r\n", endv + 1 );
			ep	= value.find( '=', sp );
			string key( value, sp, ep - sp );
			
			//cout << key.c_str() << endl;


			// boundary, charset, filename, name, etc ...
			//if ( __stricmp( key.c_str(), "boundary" ) ) {
				sp = value.find_first_not_of("\"' \t", ep + 1 );
				ep = value.find_first_of("\"' \t\r\n", sp + 1 );
				string sv1 ( value, sp, ep - sp);
				//cout << sv1 << endl;
				m_map_header.insert( map<string, string>::value_type( key, sv1 ) );
			//}

			// ';'  ڰ ߶ 
			value.erase( endv );
		}
	}

	return true;
}














/**
	boundary  Ʈ ޼ иϰ   

@param
	m_data     ִ.
@process
	1. ó boundary  ã´.
	2.  boundary  ã´.
		-- "boundary--"    ڿ "--"  پ  и ׸д.
		-- ã boundary    list  Ѵ.
		-- 2.  ư  boundary  иѴ.
*/
int MailDecoder::ParseBoundary()
{

	char *sp, *ep;
	const char *B = GetBoundary();
	int bLen = strlen( GetBoundary() );

	ep = (char *) m_message_body;
	sp = strstr( ep, B ) + bLen;
	__eo_white( sp );

	while ( sp ) {
		ep = strstr( sp, B );
		if ( ep == NULL ) 
			break;

		string part( sp, ep );
		// "--boundary"  "--"  
		part.erase( part.find_last_of("\r\n") );

		// cout << "\npart << \n" << part << flush;
		m_list_part.push_back( part );


		ep += bLen;
		if ( *( ep ) == '-' && *( ep + 1 ) == '-' )
			break;
		__eo_white(ep);
		sp = ep;
	}
	return GetCountBoundary();
}

/**
	message  multpart ̰ų mixed  ,
	boundary  и Ʈ ޼  
*/
int MailDecoder::GetCountMessagePart() {
	return m_list_part.size();
}
/**
	int MailDecoder::GetCountMessagePart()   Լ
*/
int MailDecoder::GetCountBoundary() {
	return GetCountMessagePart();
}


/**
	n ° Ʈ ޼ 
*/
const char *MailDecoder::GetPartMessage( int n )
{
	return m_list_part[n].c_str();
}


/**
	 üũѴ.
	Ư, multipart ޼  ,  ִ  ˻縦 Ѵ.
	multipart    ...
*/
bool MailDecoder::CheckBody()
{
	return true;
}




/**
	޼ MIME(Ʈ)Ľϰ ڵ ͸ ڵѴ.
@note
	- ϵ ͸ ڵؼ ϴ Լ  ִ.
*/
int MailDecoder::Parse() {

	
	if ( ! ParseHeader() )
		return MALFORMED_WRONGHEADER;
	//PrintHeader();

	if ( GetBoundary() ) {
		ParseBoundary();
		MailDecoder part;
		/*
		@todo
			- Ʈ ޼ ó
				 ⼭ óϴ  ƹ͵ . ʿ ٸ  Ѵ.
				-- attachment, inline  Ľؼ  Ѵ.
			- multipart/alternative    .
		*/
		for ( int k = 0; k < GetCountBoundary(); k++ ) {
			//cout << "\n part " << k << endl;
			//cout << md.GetPartMessage( k ) << endl;

			part.Set( GetPartMessage( k ) );
			part.ParseHeader();
			if ( __stricmp( "multipart/alternative", part.GetContentType() ) ) {
				MailDecoder alt;
				if ( part.GetBoundary() && part.ParseBoundary() ) {
					/**
						text/plain, text/html  ׳ text/html  Ѵ.
					@todo
						߿ ɼ ó  ֵ  .
					*/
					alt.Set( part.GetPartMessage( 1 ) );
					alt.ParseHeader();
				//	alt.PrintHeader();
				//	cout << alt.m_message_body << endl;
				}
			}
			// part.PrintHeader();
		}
		// eo for
		// ޼ Ʈ  .
	}
	else {
		// m_message_body    ִ.
	}


	// decode charset/content-transfer-encoding...

	return 0;
}





/**
	޼ ͸ DB  Ѵ.
@note
	  ÷  ũ ϰ,
	 DB ̺ ִ´.
*/
int MailDecoder::Save()
{
	return 0;
}
















const char *MailDecoder::GetHeader()
{
	return m_string_header.c_str();
}

/**
	޼ (m_map_header)  ͸ Ѵ.
@param	const char *str
	ҹڷ ʵ  ;Ѵ.
*/
const char *MailDecoder::GetHeader(const char *str)
{
	map<string,string>::iterator k = m_map_header.find( str );
	if ( k != m_map_header.end() )
		return k->second.c_str();
	else
		return NULL;
}




/**
	content-type ڿ ͸ Ѵ.
*/
const char *MailDecoder::GetContentType()
{
	map<string,string>::iterator k = m_map_header.find( "content-type" );
	if ( k != m_map_header.end() )
		return k->second.c_str();
	else
		return NULL;
}

/**
	boundary ڿ ͸ Ѵ.
@return
	boundary  Ű  
	 boundary   ʴ´ٸ, NULL 
*/
const char *MailDecoder::GetBoundary()
{
	map<string,string>::iterator k = m_map_header.find( "boundary" );
	if ( k != m_map_header.end() )
		return k->second.c_str();
	else
		return NULL;
}


