
#  pragma warning ( disable : 4786)

#ifndef __MAIL_H_
#define __MAIL_H_

#include <iostream>
#include <string>
#include <vector>
#include <list>
#include <map>
#include <algorithm>


#define MAXBUF_HEADERLINE				1024

#define MALFORMED_WRONGHEADER			100
#define MALFORMED_WRONGBODY				101


using namespace std;


typedef map<string, string> map_kv;
typedef map_kv::value_type entry_type;

class MailDecoder {
public :
	MailDecoder();
	~MailDecoder();
	void	Set(const char *data);
	void	Reset();
	int		Parse();
	int		Save();
	bool	ParseHeader();
	
	const char *GetHeader();
	const char *GetBody();
	void	GetCountAttachment();
	void	GetAttachment(int n);
	int		GetSize();
	void	PrintHeader();
	bool	CheckMultiValue(const char *key, string& value);
	
	
	
	const char *GetHeader( const char *str );
	const char *GetContentType();
	const char *GetBoundary();
	int		ParseBoundary();
	int		GetCountMessagePart();
	int		GetCountBoundary();
	const char *GetPartMessage( int n = 0 );
	bool	CheckBody();
public :
	map_kv m_map_header;
	string m_string_header;
private :
	const char *m_data;					//  ޼
	const char *m_message_body;			//  ޼   κ,   κ
	int		m_size;
	vector<string> m_list_part;
};


#endif

